clear all; clc;
final_res = [];
final_res_reg_max = [];


[image_name, image_num] = CreateFileList('Select first yeast image');
[map_name, map_num] = CreateFileList('Select first yeast maps');

if image_num ~= map_num
    return
end
i1 = 0;
for dataset_idx = 1:image_num
    image_curr = imread(fullfile(image_name(dataset_idx).FolderName, image_name(dataset_idx).FileName));
    map_curr = imread(fullfile(map_name(dataset_idx).FolderName, map_name(dataset_idx).FileName));
    se = strel('disk',3,0);
    map_curr_open = imopen(map_curr,se);
    se = strel('disk',7,0);
    map_curr_er = imerode(map_curr_open,se);
    map_cell_edge = xor(map_curr_open, map_curr_er);
    
    [map1, segment_num] = bwlabel(map_cell_edge);
    segment_stats = regionprops(map1, 'Area', 'PixelIdxList');
    yeast_stats = regionprops(bwlabel(map_curr_open), 'Area'); 
    
    image = rgb2gray(image_curr);
    
    
    for i = 1:segment_num
        i1=i1+1;
        image_tmp = zeros(size(image));
        pixel_list = segment_stats(i).PixelIdxList;
        cell_area = yeast_stats(i).Area;
        for pixel_idx = 1:length(pixel_list)
            image_tmp(pixel_list(pixel_idx)) = image(pixel_list(pixel_idx));
        end
        image_tmp_1 = image_tmp;
        int_mean_tmp = mean(double(image(pixel_list)));
        int_std_tmp = std(double(image(pixel_list)));
        
        % Thresholds for bright pixels 
        int_threshold = int_mean_tmp + 2*int_std_tmp;
        if int_threshold > 255
            int_threshold = 255;
        end
        pixels_to_delete = find(image_tmp<int_threshold);
        for pixel_idx = 1:length(pixels_to_delete)
            image_tmp(pixels_to_delete(pixel_idx)) = 0;
        end
        
     
        
        final_res(i1,1) = cell_area;
        final_res(i1,2) = length(find(image_tmp>0));
        final_res(i1,3) = length(pixel_list);
        
        [image_tmp1, seg_num] = bwlabel(image_tmp);
        final_res(i1,4) = seg_num;
        
        regional_max_map = imregionalmax(image_tmp_1);
        [regional_max_map_i, max_num] = bwlabel(regional_max_map);
        final_res(i1,5) = max_num;
        final_res(i1,6) = dataset_idx;
        
        
        
       
    end
end

%%
final_results = [];
data = [];
for i=1:1000
    data = a(bootsam(:,i));
    patchy_cells = length(find(data>0));
    patchy_cell_percent = patchy_cells/length(a)*100;
    final_results = [final_results; patchy_cell_percent];
end
    
    
    


